function [XY_train,  XY_test]=PartitionDataTable(DataTable, training_ratio)
    % The function splits the data into training and testing samples
    
%Alin Sept. 29

    rng(42);
    full_size=size(DataTable,1);
    TrainingSampleSize= floor(full_size * training_ratio);
    
    %randsample(n,k) function returns k values sampled uniformly at random, without replacement, from the integers 1 to n.  
    train_ind=randsample( full_size ,TrainingSampleSize);

    %C=setdiff(A,B) returns the data in A that is not in B, with no repetitions. C is in sorted order.
    test_ind=setdiff(1:full_size, train_ind)';

    XY_train=DataTable(train_ind,:);
    XY_test=DataTable(test_ind,:);
    