function newXY_train=SMOTE(XY_train, delta_1, kNNeighbors)

majority_ind=find(table2array(XY_train(:,'Default_Status'))==0);
minority_ind=find(table2array(XY_train(:,'Default_Status'))==1);
%prevalence_rate=length(minority_ind)/(length(minority_ind)+length(majority_ind));
UpsampleRate=round(length(majority_ind)/length(minority_ind))-1;

smote_data=zeros(UpsampleRate*length(minority_ind),size(XY_train,2)-1);
Xdata_train=table2array(XY_train(:,1:end));

for i=1:length(minority_ind)
    
    search_data=Xdata_train(:,1:end-1);
    search_data(minority_ind(i),:)=[];
    neighbor_index=knnsearch(search_data, Xdata_train(minority_ind(i),1:end-1),'K',kNNeighbors);
    
    %randomly select UpsampleRate (3 in this case) neighbors out of the 5 nearest neighbors
   
    selected_neighbor=search_data(randsample(neighbor_index,UpsampleRate),:);
    
    %simulate UpsampleRate (3 in this case) new instances
    
    smote_data(((i-1)*UpsampleRate+1):(i*UpsampleRate),:)=Xdata_train(minority_ind(i),1:end-1)+(selected_neighbor-Xdata_train(minority_ind(i),1:end-1))*delta_1;

end


sampling_data=[smote_data,ones(UpsampleRate*length(minority_ind),1)];

sampling_data(:,[2:4,6:11])=round(sampling_data(:,[2:4,6:11]));


newXY_train=array2table([Xdata_train;sampling_data]);
newXY_train.Properties.VariableNames=XY_train.Properties.VariableNames;


